$color1: #ffffff;
$color2: #dee7ed;
$color3: #272727;
$color4: #9badb9;
$color5: #999999;
$color6: #6A7B87;
$color7: #F3F3F3;
$color8: #FF6A6A;
$color9: #ffcf68;
$color10: #e13c3c;
$color11: #558fcc;
$color12: #4272A4;
$color13: #e4ebf6;

$spinnerBg: $color1;
$spinnerBorderColor: $color9;
$multiselectColor: $color3;
$multiselectBg: $color1;
$multiselectBorderColorHover: $color11;
$multiselectBorderColorFocus: $color11;
$multiselectTagsBgColor: $color1;
$multiselectTagsBorder: 1px solid $color4;
$multiselectTagColor: $color1;
$multiselectTagBgColor: $color2;
$multiselectTagIconColor: darken($color2, 20%);
$multiselectTagIconColorHover: darken($color2, 8%);
$multiselectTagIconColorBgHover: $color1;
$multiselectCurrentBorderColor: $color4;
$multiselectBorderColor: $color5;
$multiselectErrorBorderColor: $color10;
$multiselectPlaceholderColor: $color6;
$multiselectContentBgColor: $color1;
$multiselectContentBorderColor: $color4;
$multiselectOptionHighlightBgColor: $color13;
$multiselectOptionHighlightColor: $color3;
$multiselectOptionSelectedBgColor: $color2;
$multiselectOptionSelectedColor: $color3;
$multiselectOptionHighlightSelectedBgColor: $color2;
$multiselectOptionHighlightSelectedColor: $color3;
$multiselectDisabledBgColor: #eef3f6;
$multiselectDisabledColor: #6a7b87;
$multiselectDisabledOptionBgColor: darken($color2, 3%);

$multiselectTagIcon: "\00D7";
$multiselectTagsBorderRadius: 0.1875rem;

$blue-300: #4272A4;

fieldset[disabled] .multiselect {
  pointer-events: none
}

.multiselect * {
  box-sizing: border-box;
}

.multiselect {
  box-sizing: border-box;
  font-family: inherit;
  font-size: 0.8125rem;
  touch-action: manipulation;
  &.partname-multiselect {
    & .multiselect__select {
      display: none !important;
    }
    &__empty--val .multiselect__content-wrapper {
      display: none !important;
    }
    &__empty--opt .multiselect__content li:first-child {
      height: 3rem;
    }
    .multiselect__option {
      max-height: 3rem;
    }
    p {
      white-space: pre-line;
      font-size: 0.75rem;
      font-weight: bold !important;
      color: #7e7e7e !important;
    }
  }

  &__spinner {
    position: absolute;
    right: 0.0625rem;
    top: 0.0625rem;
    width: 1.875rem;
    height: 1.875rem;
    background: $spinnerBg;
    display: block;
    @media only screen and (max-width: 1024px) {
      right: 0.0625rem;
      top: 0.0625rem;
      width: 3rem;
      height: 3rem;
    }

    &:after,
    &:before {
      position: absolute;
      content: "";
      top: 50%;
      left: 50%;
      margin: -0.5rem 0 0 -0.5rem;
      width: 1rem;
      height: 1rem;
      border-radius: 100%;
      border-color: #ffcf68 transparent transparent;
      border-style: solid;
      border-width: 0.125rem;
      box-shadow: 0 0 0 1px transparent;
      @media only screen and (max-width: 1024px) {
        width: 1.8rem;
        height: 1.8rem;
        margin: -1rem 0 0 -1rem;
      }
    }

    &:before {
      animation: a 2.4s cubic-bezier(.41, .26, .2, .62);
      animation-iteration-count: infinite;
    }

    &:after {
      animation: a 2.4s cubic-bezier(.51, .09, .21, .8);
      animation-iteration-count: infinite;
    }
  }
  &__loading-enter-active,
  &__loading-leave-active {
    transition: opacity .4s ease-in-out;
    opacity: 1;
  }
  &__loading-enter,
  &__loading-leave-active,
  &-enter,
  &-leave-active {
    opacity: 0;
  }
  &-enter-active,
  &-leave-active {
    transition: all .15s ease;
  }

  &.multiselect__flag {
    width: 3.5rem !important;
    min-width: 3.5rem !important;
    .multiselect__select {
      display: none;
    }
    .multiselect__tags {
      padding-right: 0.75rem;
      padding-left: 0.75rem;
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
      border-right-color: $multiselectBorderColor !important;
    }
    .multiselect__single,
    .multiselect__option {
      text-align: center;
    }
    &.multiselect--active {
      + .ui.input input {
        border-color: $multiselectBorderColorFocus;
      }
    }
    + .ui.input {
      flex: 0 1 100%;
      width: 100%;
      max-width: calc(100% - 3.5rem);
      input {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
        border-left: none;
      }
    }
  }

  input {
    max-width: 100%;
    border: none !important;
    outline: none;
    padding: 0 !important;
    margin: 0 !important;
    opacity: 1 !important;
    &::-webkit-input-placeholder {
      color: $multiselectPlaceholderColor;
      opacity: 1;
      text-overflow: ellipsis;
    }
    &::-moz-placeholder {
      color: $multiselectPlaceholderColor;
      opacity: 1;
      text-overflow: ellipsis;
    }
    &:-moz-placeholder {
      color: $multiselectPlaceholderColor;
      opacity: 1;
      text-overflow: ellipsis;
    }
    &:-ms-input-placeholder {
      color: $multiselectPlaceholderColor;
      opacity: 1;
      text-overflow: ellipsis;
    }
  }

  * {
    box-sizing: border-box;
  }

  display: block;
  position: relative;
  width: 100%;
  min-height: 2rem;
  text-align: left;
  color: $multiselectColor;

  &:focus {
    outline: none;
  }

  &--active {
    z-index: 10;
    .multiselect__tags {
      border-color: $multiselectBorderColorHover;
    }
    .multiselect__input {
      width: 100% !important;
    }
    .multiselect__strong {
      display: none;
    }

  }

  &__content-wrapper {
    @media only screen and ( max-height: 720px ) {
      max-height: 200px !important;
    }
    @media only screen and ( max-height: 600px ) {
      max-height: 160px !important;
    }
  }
}

.multiselect,
.multiselect__input,
.multiselect__single {
  font-family: inherit;
  font-size: 0.8125rem;
  touch-action: manipulation;
  @media only screen and (max-width: 1024px) {
    font-size: 0.9375rem;
  }
}

.multiselect__input,
.multiselect__single {
  position: relative;
  display: inline-block;
  min-height: 1.25rem;
  line-height: 1.25rem;
  border: none !important;
  border-radius: $multiselectTagsBorderRadius;
  background: $multiselectBg;
  padding: 0;
  outline: none;
  width: 100%;
  transition: border .1s ease;
  box-sizing: border-box;
  margin: 0;

  &:hover {
    border-color: transparent;
  }

  &:focus {
    border-color: transparent;
    outline: none;
  }
}

.multiselect__single {
  padding-left: 0;
  margin-bottom: 0;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  color: $multiselectColor;
  > .flag {
    display: inline-block;
    width: 1rem;
    margin-right: .5rem;
    vertical-align: middle;
  }
  &:empty {
    display: none;
  }
}

.multiselect__input {
  &::-webkit-input-placeholder,
  &:-ms-input-placeholder,
  &::placeholder {
    color: $multiselectPlaceholderColor;
    text-overflow: ellipsis;
  }
  + .multiselect__single {
    color: $multiselectColor;
  }
}

.multiselect__tags {
  min-height: 2rem;
  display: block;
  padding: 0.3125rem 2rem 0 0.9375rem;
  border-radius: $multiselectTagsBorderRadius;
  border: $multiselectTagsBorder;
  background: $multiselectTagsBgColor;
  font-size: 0.8125rem;
  line-height: 1rem;
  @media only screen and (max-width: 1024px) {
    min-height: 3rem;
    font-size: 0.9375rem;
    padding: 0.875rem 3.25rem 0.5rem 1rem;
  }
  &-wrap {
    display: inline;
  }
}

.multiselect__tag {
  position: relative;
  display: inline-block;
  padding: 0.25rem 1.625rem 0.25rem 0.625rem;
  border-radius: 0.3125rem;
  margin-right: 0.625rem;
  color: #141414;
  line-height: 1;
  background: #ffcf68;
  margin-bottom: 0.3125rem;
  white-space: nowrap;
  overflow: hidden;
  max-width: 100%;
  text-overflow: ellipsis;

  & ~ .multiselect__input,
  & ~ .multiselect__single {
    width: auto;
  }
}

.multiselect__tag-icon {
  cursor: pointer;
  margin-left: 7px;
  position: absolute;
  right: 0;
  top: 0;
  bottom: 0;
  font-weight: 700;
  font-style: normal;
  width: 22px;
  text-align: center;
  line-height: 22px;
  transition: all .2s ease;
  border-radius: $multiselectTagsBorderRadius;

  &:after {
    content: $multiselectTagIcon;
    color: $multiselectTagIconColor;
    font-size: 0.875rem;
  }
  &:focus, &:hover {
    background: $multiselectTagIconColorHover;

    &:after {
      color: $multiselectTagIconColorBgHover;
    }
  }
}

.multiselect__current {
  min-height: 40px;
  overflow: hidden;
  padding: 8px 12px 0;
  padding-right: 30px;
  white-space: nowrap;
  border-radius: $multiselectTagsBorderRadius;
  border: 1px solid $multiselectCurrentBorderColor;
}

.multiselect__current,
.multiselect__select {
  line-height: 1rem;
  box-sizing: border-box;
  display: block;
  margin: 0;
  text-decoration: none;
  cursor: pointer;
}

.multiselect__clear,
.multiselect__select {
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
  width: 2rem;
  height: calc(100% - 0.5rem);
  right: 1px;
  top: 0.25rem;
  bottom: 0.25rem;
  padding: 0;
  margin: 0;
  outline: none;
  text-align: center;
  border-left: 1px solid $multiselectContentBorderColor;
  cursor: pointer;
  @media only screen and (max-width: 1024px) {
    width: 3rem;
  }
}
.multiselect__clear {
  background: #fff;
}

.multiselect__select {
  &:before {
    content: "";
    display: inline-block;
    color: #9badb9;
    margin: 0;
    border-style: none;
    width: 100%;
    height: 100%;
    background-image: url("~assets/svg/arrow/up-thin.svg");
    background-repeat: no-repeat;
    background-position: center;
    background-size: 1rem auto;
    transform: rotate(180deg);
    @media only screen and (max-width: 1024px) {
      background-size: 40% auto;
    }
  }
}

.multiselect__clear {
  background-image: url("~assets/svg/icons/i-close.svg");
  background-position: center;
  background-repeat: no-repeat;
  background-size: 0.75rem;
  @media only screen and (max-width: 1024px) {
    font-size: 1rem;
  }
}

.multiselect__placeholder {
  color: $multiselectPlaceholderColor;
  display: inline-block;
  line-height: 1.25rem;
  max-height: 1.25rem;
  width: 100%;
  margin: 0;
  padding: 0;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;

  .multiselect--active & {
    display: none;
  }
}

.multiselect__content {
  list-style: none;
  display: inline-block;
  padding: 0;
  margin: 0;
  min-width: 100%;
  width: 100%;
  max-width: inherit;
  vertical-align: top;

  &-wrapper {
    position: absolute;
    display: block;
    background: $multiselectContentBgColor;
    width: 100%;
    max-height: 15rem;
    overflow: auto;
    border: 1px solid $multiselectContentBorderColor;
    border-top: none;
    border-bottom-left-radius: $multiselectTagsBorderRadius;
    border-bottom-right-radius: $multiselectTagsBorderRadius;
    box-shadow: 0 0.25rem 12px 0 rgba(96, 126, 146, 0.22);
    z-index: 1;
    -webkit-overflow-scrolling: touch;

    .multiselect--above & {
      bottom: 100%;
      border-bottom-left-radius: 0;
      border-bottom-right-radius: 0;
      border-top-left-radius: $multiselectTagsBorderRadius;
      border-top-right-radius: $multiselectTagsBorderRadius;
      border-bottom: none;
      border-top: 1px solid $multiselectContentBorderColor;
    }

  }

  &::webkit-scrollbar {
    display: none;
  }
}

.multiselect__element {
  display: block;
  max-width: 100%;
}

.multiselect__checkbox {
  //margin-bottom: -2px !important;
  width: 100%;
  height: 1.125rem !important;
  line-height: 1.125rem !important;
  max-width: inherit;
  overflow: hidden;
  text-overflow: ellipsis;
  margin: 0 !important;
  font: inherit !important;
  padding-top: 2px;
  padding-left: 1.5rem;
  position: relative;
  &:before {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: 1rem;
    height: 1rem;
    background-color: #fff;
    border-radius: 0.1875rem;
    border: $multiselectTagsBorder;
  }
  &:after {
    display: none;
    content: '\e800';
    position: absolute;
    top: 0;
    left: 0;
    width: 1rem;
    text-align: center;
    font-size: 0.6875rem;
    line-height: 1rem;
    font-family: 'Checkbox';
    color: $color12;
  }
  @media only screen and (max-width: 1024px) {
    height: 1.4375rem !important;
    line-height: 4.375rem !important;
    padding-left: 1.875rem;
    &:before {
      width: 1.3125rem;
      height: 1.3125rem;
    }
    &:after {
      width: 1.3125rem;
      font-size: 0.9375rem;
      line-height: 1.3125rem;
    }
  }
}

.multiselect__option--selected .multiselect__checkbox:after {
  display: block;
}

.multiselect__option {
  display: block;
  min-height: 2rem;
  max-height: 2rem;
  max-width: inherit;
  padding: 0.5rem 1rem 0.5rem 2.5rem;
  font-size: 0.8125rem;
  line-height: 1rem;
  text-decoration: none;
  text-transform: none;
  vertical-align: middle;
  position: relative;
  cursor: pointer;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  color: $multiselectColor;
  * {
    font: inherit !important;
    color: inherit !important;
    line-height: inherit;
  }
  &:before, &:after {
    position: absolute;
    top: 50%;
    left: 1rem;
    margin-top: -0.5rem;
    width: 1rem;
    height: 1rem;
  }
  &:before {
    content: '';
    background-color: #fff;
    border-radius: 0.1875rem;
    border: $multiselectTagsBorder;
  }
  &:after {
    display: none;
    content: '\e800';
    text-align: center;
    font-size: 0.6875rem;
    line-height: 1rem;
    font-family: 'Checkbox';
    color: $color12;
  }
  @media only screen and (max-width: 1024px) {
    min-height: 3rem;
    max-height: 3rem;
    font-size: 0.9375rem;
    padding: 0.875rem 1rem 0.5rem;
    line-height: 1rem !important;
    padding-left: 2.875rem;
    &:before, &:after {
      width: 1.3125rem;
      height: 1.3125rem;
      margin-top: -0.8125rem;
    }
    &:after {
      font-size: 0.9375rem;
      line-height: 1.3125rem;
    }
  }

  > .flag {
    display: inline-block;
    width: 1rem;
    margin-right: .5rem;
    vertical-align: middle;
  }

  &--highlight {
    background: $multiselectOptionHighlightBgColor;
    outline: none;
    color: $multiselectOptionHighlightColor;

    &:after {
      //content: attr(data-select);
      //color: $multiselectOptionHighlightColor;
    }
  }

  &--selected {
    background: $multiselectOptionSelectedBgColor;
    color: $multiselectOptionSelectedColor;
    &:before, &:after {
      display: block;
    }

    &:after {
      //content: attr(data-selected);
      //color: darken($multiselectOptionSelectedBgColor, 20%);
    }
  }
  .option__desc{
    display: flex;
    justify-content: space-between;
    .option__title{
      width: 65%;
      text-overflow: ellipsis;
      overflow: hidden;
    }
    .option__small{
      max-width: 30%;
      font-size: 0.625rem !important;
      color: #868686 !important;
    }
  }
}

.multiselect.no-checkbox .multiselect__option {
  padding-left: 1rem;
  &:before, &:after {
    display: none;
  }
}

// @todo что-нибудь более переиспользуемое
.multiselect.first-10-bold .multiselect__element:nth-child(-n+10) {
  font-weight: 700;
}

.multiselect__option--selected.multiselect__option--highlight {
  background: $multiselectOptionHighlightSelectedBgColor;
  color: $multiselectOptionHighlightSelectedColor;

  &:after {
    //content: attr(data-deselect);
    //color: $multiselectOptionHighlightSelectedColor;
  }
}

.multiselect--disabled {
  background: $multiselectDisabledBgColor;
  pointer-events: none;

  .multiselect__current,
  .multiselect__single,
  .multiselect__tags {
    background: $multiselectDisabledBgColor;
    color: $multiselectDisabledColor;
  }
  .multiselect__clear, .multiselect__select {
    background: transparent;
    border-color: #c5d1d9;
    &:before {
      color: #c5d1d9;
    }
  }
  .multiselect__tags {
    border-color: #c5d1d9;
  }
}

.multiselect__option--disabled {
  background: $multiselectDisabledBgColor;
  color: $multiselectDisabledColor;
  cursor: text;
  pointer-events: none;

  &.multiselect__option--highlight {
    background: #dedede;
  }

  &:visited {
    color: $multiselectDisabledColor;
  }

  &:hover,
  &:focus {
    background: $multiselectDisabledOptionBgColor;
  }
}

.multiselect__option--group {
  background: #ededed;
  color: #35495e;

  &.multiselect__option--highlight {
    background: #35495e;
    color: #fff;

    &:after {
      //background: #35495e;
    }
  }

  &-selected.multiselect__option--highlight {
    background: #ff6a6a;
    color: #fff;

    &:after {
      //background: #ff6a6a;
      //content: attr(data-deselect);
      //color: #fff;
    }
  }
}

.multiselect__strong {
  margin-bottom: 0;
  line-height: 1.25rem;
  display: inline-block;
  vertical-align: top;
  color: $multiselectColor;
  font-size: 0.8125rem;
  font-weight: 400;
  @media only screen and (max-width: 1024px) {
    font-size: 0.9375rem;
  }
}

[dir=rtl] .multiselect {
  text-align: right;
}

[dir=rtl] .multiselect__select {
  right: auto;
  left: 1px;
}

[dir=rtl] .multiselect__tags {
  padding: 8px 8px 0 40px;
}

[dir=rtl] .multiselect__content {
  text-align: right;
}

[dir=rtl] .multiselect__option:after {
  //right: auto;
  //left: 0;
}

[dir=rtl] .multiselect__clear {
  right: auto;
  left: 12px;
}

[dir=rtl] .multiselect__spinner {
  right: auto;
  left: 1px;
}

@keyframes a {
  0% {
    transform: rotate(0)
  }
  to {
    transform: rotate(2turn)
  }
}

.multiselect__wide .multiselect__content-wrapper {
  width: inherit;
  overflow-y: auto;
  overflow-x: hidden;
}

.has-error .multiselect .multiselect__tags {
  border-color: $multiselectErrorBorderColor;
}

.filled-blue {
  .multiselect.multiselect__flag .multiselect__tags,
  .multiselect__tags {
    background-color: #eef3f6!important;
    border-color: #558fcc!important;
    .multiselect__input,
    .multiselect__single {
      background-color: transparent;
    }
  }
}

.multiselect.multiselect__small {
  min-height: 1.375rem;
  height: 1.375rem;
  font-weight: 400;
  .multiselect__tags {
    min-height: 1.375rem;
    font-size: 0.625rem;
    line-height: 1;
    padding: 0.1875rem 1.5rem 0 0.625rem;
  }
  .multiselect__clear,
  .multiselect__select {
    width: 1.5rem;
  }
  .multiselect__input,
  .multiselect__single,
  .multiselect__placeholder {
    font-size: 0.625rem;
    font-weight: 400;
    min-height: 1rem;
    line-height: 1rem;
  }
  .multiselect__option {
    min-height: 1.5rem;
    max-height: 1.5rem;
    padding: 0.25rem 0.625rem 0.25rem 1.875rem;
    font-size: 0.625rem;
    line-height: 1.75;
    &:before, &:after {
      left: 0.5rem;
    }
  }
  &.no-checkbox .multiselect__option {
    padding-left: 0.625rem;
  }
}

.button-right {
  .multiselect.multiselect__flag .multiselect__tags {
    .multiselect__single {
      background-color: transparent;
    }
    @media screen and (max-width: 479px) {
      border-bottom-left-radius: 0;
    }
  }
}

.no-opt-as-simple {
  background: #fff !important;
  color: #272727 !important;
  border-color: #9badb9 !important;
  .multiselect__tags {
    background: #fff !important;
    color: #272727 !important;
    border: 1px solid #9badb9 !important;
    border-color: #9badb9 !important;
    .multiselect__single {
      background: #fff !important;
      color: #272727 !important;
    }
  }
}

.multiselect {
  ::-webkit-scrollbar-button {
    background-image: none;
    background-repeat: no-repeat;
    width: 0;
    height: 0;
  }

  ::-webkit-scrollbar-track {
    background-color: #ededed;
  }

  ::-webkit-scrollbar-thumb {
    -webkit-border-radius: 0px;
    border-radius: 0px;
    background-color: #4a7db4;
  }

  ::-webkit-scrollbar-thumb:hover {
    background-color: #345a81;
  }

  ::-webkit-resizer {
    background-image: none;
    background-repeat: no-repeat;
    width: 0.3125rem;
    height: 0.3125rem;
  }

  ::-webkit-scrollbar {
    width: 0.3125rem;
    height: 0.3125rem;
  }

  ::-moz-scrollbar-button {
    background-image: none;
    background-repeat: no-repeat;
    width: 0;
    height: 0;
  }

  ::-moz-scrollbar-track {
    background-color: #ededed;
  }

  ::-moz-scrollbar-thumb {
    -webkit-border-radius: 0px;
    border-radius: 0px;
    background-color: #4a7db4;
  }

  ::-moz-scrollbar-thumb:hover {
    background-color: #345a81;
  }

  ::-moz-resizer {
    background-image: none;
    background-repeat: no-repeat;
    width: 0.3125rem;
    height: 0.3125rem;
  }

  ::-moz-scrollbar {
    width: 0.3125rem;
    height: 0.3125rem;
  }
}
